#!/bin/bash
D_DEV_KMSG=/dev/kmsg
echo_title_2kmsg()
{
	echo "=====================================" > ${D_DEV_KMSG}
	echo $@ > ${D_DEV_KMSG}
	echo "=====================================" >  ${D_DEV_KMSG}
}

511_nvidia_trace_log()
{
	#Step.0
	echo 1 > /sys/kernel/debug/bpmp/debug/clk/vi/mrq_rate_locked
	echo 1 > /sys/kernel/debug/bpmp/debug/clk/isp/mrq_rate_locked
	echo 1 > /sys/kernel/debug/bpmp/debug/clk/nvcsi/mrq_rate_locked
	cat /sys/kernel/debug/bpmp/debug/clk/vi/max_rate |tee /sys/kernel/debug/bpmp/debug/clk/vi/rate
	cat /sys/kernel/debug/bpmp/debug/clk/isp/max_rate | tee  /sys/kernel/debug/bpmp/debug/clk/isp/rate
	cat /sys/kernel/debug/bpmp/debug/clk/nvcsi/max_rate | tee /sys/kernel/debug/bpmp/debug/clk/nvcsi/rate
	
	#Step nvidia
	# https://forums.developer.nvidia.com/t/csi-camera-driver-malfunctions-with-rt-patch/220376/8	
	echo 1 > /sys/kernel/debug/tracing/tracing_on
	echo 30720 > /sys/kernel/debug/tracing/buffer_size_kb
	echo 1 > /sys/kernel/debug/tracing/events/tegra_rtcpu/enable
	echo 1 > /sys/kernel/debug/tracing/events/freertos/enable
	echo 2 > /sys/kernel/debug/camrtc/log-level
	
	echo 1 > /sys/kernel/debug/tracing/events/camera_common/enable
	echo file vi5_fops.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file csi.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file csi5_fops.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file nvcsi.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file camera_common.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file sensor_common.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file mipi_cal.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file i2c_dev.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file i2c_tegra_vi.c +p > /sys/kernel/debug/dynamic_debug/control
	# empty trace log
	echo > /sys/kernel/debug/tracing/trace
	sleep 1	
	# print trace log
	#cat /sys/kernel/debug/tracing/trace
	
	# review dynamic tracing log
	cat /sys/kernel/debug/tracing/trace_pipe |& tee -a  $(date '+%Y%m%d_%H%M%S').txt
}

510_mipi_trace_log()
{
	#Step.0
	echo 1 > /sys/kernel/debug/bpmp/debug/clk/vi/mrq_rate_locked
	echo 1 > /sys/kernel/debug/bpmp/debug/clk/isp/mrq_rate_locked
	echo 1 > /sys/kernel/debug/bpmp/debug/clk/nvcsi/mrq_rate_locked
	cat /sys/kernel/debug/bpmp/debug/clk/vi/max_rate |tee /sys/kernel/debug/bpmp/debug/clk/vi/rate
	cat /sys/kernel/debug/bpmp/debug/clk/isp/max_rate | tee  /sys/kernel/debug/bpmp/debug/clk/isp/rate
	cat /sys/kernel/debug/bpmp/debug/clk/nvcsi/max_rate | tee /sys/kernel/debug/bpmp/debug/clk/nvcsi/rate

	#Step.1
	echo 1 > /sys/kernel/debug/tracing/tracing_on
	echo 30720 > /sys/kernel/debug/tracing/buffer_size_kb
	echo 1 > /sys/kernel/debug/tracing/events/tegra_rtcpu/enable
	echo 1 > /sys/kernel/debug/tracing/events/freertos/enable
	echo 2 > /sys/kernel/debug/camrtc/log-level
	echo 1 > /sys/kernel/debug/tracing/events/camera_common/enable
	
	#echo > /sys/kernel/debug/tracing/trace
	echo 2 > /sys/class/video4linux/video0/dev_debug
	echo 2 > /sys/class/video4linux/video1/dev_debug
	echo file vi5_fops.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file csi.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file csi5_fops.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file nvcsi.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file camera_common.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file sensor_common.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file mipi_cal.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file i2c_dev.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file i2c_tegra_vi.c +p > /sys/kernel/debug/dynamic_debug/control

	#Step.2
	tail -f /sys/kernel/debug/tracing/trace |& tee -a  $(date '+%Y%m%d_%H%M%S').txt

	
}	


main()
{
	echo_title_2kmsg "0.start trace log"
	#510_mipi_trace_log
	511_nvidia_trace_log
}

main $@
