#!/bin/bash
# VERSION 	5.6
# DATE		2022/07/22
# performance test for differenct test case

source "bash_functions.sh"

D_DEV_NO=0
D_DEV_INPUT_HDMI=0
D_DEV_INPUT_DVI=1
D_DEV_INPUT_SDI=4
D_DEV_INPUT=${D_DEV_INPUT_HDMI}
#D_WIDTH=3840
#D_HEIGHT=2160
D_WIDTH=1920
D_HEIGHT=1080
#D_WIDTH=1280
#D_HEIGHT=720
#D_HEIGHT=486
#D_WIDTH=640
#D_HEIGHT=480
#D_FORMAT_GST="YV12"
#D_FORMAT_GST="NV12"
#D_FORMAT_GST="YUY2"
#D_FORMAT_GST="I420"
D_FORMAT_GST="UYVY"
#D_FORMAT_GST="BGR"
#D_FORMAT_GST="RGB"
#D_STAND="ntsc-M"
D_STAND="pal-H"

D_SCALE_720P=1

DIR_CURR=`pwd`
FN="${DIR_CURR}/"$(date +%Y%m%d_%H%M%S)".264"
D_BACKGROUND=0

# Input Parameter - test case id
P_ID_CASE=1

# Input Parameter - decode file name
P_FN_DEC264=""

# Input parameter - multi channel
P_IS_MULTI=0

#if use mipi pipeline to test
P_IS_MIPI=0

P_VAAPI=0

# 09.GOP
GOP=30
# 07.Bitrate of H264 encode (12Mb/sec)
BITRATE=120000000
BITRATE_x264enc=2048
FRAMERATE=60
TIME_DELAY=0
# streaming
D_PORT=8888
#IP_SERVER=127.0.0.1
IP_SERVER=10.10.40.85
#IP_SERVER=10.10.40.115

D_INDEX=0
D_SCALE="0"
D_SCALE_RATIO=0.5
#D_WIDTH_SCALE=$(( D_WIDTH*D_SCALE_RATIO ))
#D_HEIGHT_SCALE=$(( D_HEIGHT*D_SCALE_RATIO ))

D_WIDTH_SCALE=$(echo ${D_WIDTH}*${D_SCALE_RATIO} | bc | cut -d "." -f 1)
D_HEIGHT_SCALE=$(echo ${D_HEIGHT}*${D_SCALE_RATIO} | bc | cut -d "." -f 1)

GST_FRAMERATE=${FRAMERATE}
#GST_FRAMERATE=$((D_FRAMERATE*1000/1001))
S_CMD=""
P1_ID_CASE=1
P2_IS_MULTI=0
P3_FN_DEC=""
D_NO_MULT_CHAN=4

#H265
# nvv4l2h265enc
D_GST_V4L2_VIDENC_VARIABLE_BITRATE=0
D_GST_V4L2_VIDENC_CONSTANT_BITRATE=1

#omxh265enc
D_O265_CRATE_DISABLE=0
D_O265_CRATE_VARIABLE=1
D_O265_CRATE_CONSTANT=2
D_O265_CRATE_V_SFRAME=3
D_O265_CRATE_C_SFRAME=4

D_265_CTL_RATE=${D_GST_V4L2_VIDENC_VARIABLE_BITRATE}
#40k
#D_265_BRATE=400000

#400k
#D_265_BRATE=4000000
#4M
#D_265_BRATE=40000000

# 12M
D_265_BRATE=120000000

D_FILE_H265=0
D_FILE_MP4=1
D_SAVE_FTYPE=${D_FILE_H265}

D_DMODE_NMMAP=0
D_DMODE_USERPRT=1
D_DMODE_GPUDIRECT=2
D_DRIVER_MODE=${D_DMODE_NMMAP}

# terminate by buffer size
D_NUM_BUFFER=1000

exec_gstcmd()
{
	if [ ${D_BACKGROUND} = 0 ];then
		run_cmd $@
	else
		run_cmd_bg $@
	fi
}

51_get_dev_no()
{
	
	#get the next line of finding
	#v4l2-ctl --list-devices | awk '/12abf55c/{getline;print}'
	
	#remove space by sed
	#v4l2-ctl --list-devices | awk '/12abf55c/{getline;print}' | sed 's/ //g'
	
	#remove tab by tr
	#12abf5cb-4ch
	#12abf55c-550
	DEV_NAME=$(v4l2-ctl --list-devices | awk '/12abf55c/{getline;print}' | tr -d '\t' )
	#DEV_NAME=$(v4l2-ctl --list-devices | awk '/12abf5cb/{getline;print}' | tr -d '\t' | head -n 1 )
	echo ${DEV_NAME}	

	v4l2-ctl --device=${DEV_NAME} -i ${DEV_INPUT}
	sleep 5
}

52_win_reset()
{
	i=0
	x=50
	
	wmctrl -l | 
	while read -r line
	do
		echo $line
		WID=$(echo $line | cut -d ' ' -f 1)
		F3=$(echo $line | cut -d ' ' -f 3)
		#F3=$(${line} )
		echo $F3
		if [ $F3 == "N/A" ];then
			wmctrl -i -r $WID -b remove,maximized_vert
			wmctrl -i -r $WID -b remove,maximized_horz
			#sleep 2
			wmctrl -i -a $WID
			#sleep 2
			#wmctrl -v -i -R $WID -e 0,0,0,1920,1080
			if [ ${i} -lt 4 ];then
				(( x = 700*${i} + 50))
				y=100
			else
				(( x = 700*$((i -4)) + 50))
				y=680
			fi			

			wmctrl -v -i -R $WID -e 0,${x},${y},640,480

			(( i += 1 ))
			
		fi
	done	
}

53_test_loop()
{
	count=0
	x=1
	for i in {0,1,2,3}
	do
		x=1
		echo  "i=$i"
		(( count += 1 ))
		
		if [ ${i} -lt 2 ];then
			echo "0,1"
			(( x *= ${count} ))
		else
			echo "2,3"
			(( x *= (${count} -2 )))
		fi
		
		echo  "$i,count=${count},x=${x}"
	done
	
}

# https://unix.stackexchange.com/questions/299321/bash-multiplication-and-addition
54_test_float()
{
	echo ${D_WIDTH_SCALE}
	echo ${D_HEIGHT_SCALE}
}

55_set_nvpmodel()
{
	D_MACHINE=${D_MACHINE_TX2} 
	
	case ${D_MACHINE} in
	${D_MACHINE_TX2} | ${D_MACHINE_XAVIER} | ${D_MACHINE_ORIN} | ${D_MACHINE_CLARA} ) 
		run_cmd nvpmodel -m 0 ;;
	
	${D_MACHINE_NX} )
		run_cmd nvpmodel -m 2 ;;
		
	${D_MACHINE_X86} | * )
		return ;;
	esac
	
	# enable to max frequency
	jetson_clocks
}

# Orin nvfancontrol : https://docs.nvidia.com/jetson/archives/r34.1/DeveloperGuide/text/SD/PlatformPowerAndPerformance/JetsonOrinNxSeriesAndJetsonAgxOrinSeries.html
56_set_fan()
{
	case ${D_MACHINE} in
	${D_MACHINE_TX2} | ${D_MACHINE_XAVIER} | ${D_MACHINE_CLARA} ) 
		echo 100 > /sys/devices/pwm-fan/target_pwm ;;
	
	${D_MACHINE_NX} )
		echo 100 > /sys/devices/pwm-fan/target_pwm ;;
	esac
}

57_test_rgba()
{
	run_cmd gst-launch-1.0 -v videotestsrc pattern=smpte ! "video/x-raw,width=${D_WIDTH},height=${D_HEIGHT},framerate=60/1, format=(string)RGB" ! \
	queue ! videoconvert ! "video/x-raw,width=${D_WIDTH},height=${D_HEIGHT},framerate=60/1, format=(string)RGBA" ! nvvidconv ! "video/x-raw(memory:NVMM),format=RGBA" ! \
	nv3dsink sync=false -v -e
}

58_test_bgra()
{
	run_cmd gst-launch-1.0 -v videotestsrc pattern=smpte ! \
	queue ! videoconvert ! nvvidconv ! "video/x-raw(memory:NVMM),format=RGB16" ! \
	nv3dsink sync=false -v -e
}

#it use x11 to display
59_test_rgb_nveglglessink()
{
	# fail
	run_cmd gst-launch-1.0 -v videotestsrc pattern=smpte ! "video/x-raw,width=${D_WIDTH},height=${D_HEIGHT},framerate=60/1, format=(string)RGB" ! \
	queue ! videoconvert ! "video/x-raw,width=${D_WIDTH},height=${D_HEIGHT},framerate=60/1, format=(string)RGBA" ! nvvidconv ! "video/x-raw(memory:NVMM),format=RGBA" ! \
	nveglglessink sync=false -v -e
}

510_mipi_trace_log()
{
	#Step.0
	echo 1 > /sys/kernel/debug/bpmp/debug/clk/vi/mrq_rate_locked
	echo 1 > /sys/kernel/debug/bpmp/debug/clk/isp/mrq_rate_locked
	echo 1 > /sys/kernel/debug/bpmp/debug/clk/nvcsi/mrq_rate_locked
	cat /sys/kernel/debug/bpmp/debug/clk/vi/max_rate |tee /sys/kernel/debug/bpmp/debug/clk/vi/rate
	cat /sys/kernel/debug/bpmp/debug/clk/isp/max_rate | tee  /sys/kernel/debug/bpmp/debug/clk/isp/rate
	cat /sys/kernel/debug/bpmp/debug/clk/nvcsi/max_rate | tee /sys/kernel/debug/bpmp/debug/clk/nvcsi/rate

	#Step.1
	echo 1 > /sys/kernel/debug/tracing/tracing_on
	echo 30720 > /sys/kernel/debug/tracing/buffer_size_kb
	echo 1 > /sys/kernel/debug/tracing/events/tegra_rtcpu/enable
	echo 1 > /sys/kernel/debug/tracing/events/freertos/enable
	echo 2 > /sys/kernel/debug/camrtc/log-level
	echo 1 > /sys/kernel/debug/tracing/events/camera_common/enable
	
	#echo > /sys/kernel/debug/tracing/trace
	echo 2 > /sys/class/video4linux/video0/dev_debug
	echo 2 > /sys/class/video4linux/video1/dev_debug
	echo file vi5_fops.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file csi.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file csi5_fops.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file nvcsi.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file camera_common.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file sensor_common.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file mipi_cal.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file i2c_dev.c +p > /sys/kernel/debug/dynamic_debug/control
	echo file i2c_tegra_vi.c +p > /sys/kernel/debug/dynamic_debug/control

	#Step.2
	cat /sys/kernel/debug/tracing/trace |& tee -a  $(date '+%Y%m%d_%H%M%S').txt

	
}


1_1_getfps_mipi()
{
	echo_title "getfps_mipi-video${D_DEV_NO}"
	#exec_gstcmd gst-launch-1.0 nvv4l2camerasrc device="/dev/video${D_DEV_NO}" ! queue ! \
	#	"video/x-raw(memory:NVMM), format=(string)${D_FORMAT_GST} , width=(int)${D_WIDTH}, height=(int)${D_HEIGHT},interlace-mode= progressive" ! \
	#	fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v -e		 	

	exec_gstcmd gst-launch-1.0 nvv4l2camerasrc device="/dev/video${D_DEV_NO}" ! queue ! \
		"video/x-raw(memory:NVMM), format=(string)${D_FORMAT_GST} , width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v -e		 	
}
  
1_0_getfps()
{
	echo_title "getfps-video${D_DEV_NO}"
	exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST} , width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v -e

	#exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" ! queue ! "video/x-raw, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	#fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v -e
}

# https://docs.nvidia.com/jetson/archives/l4t-archived/l4t-3261/index.html#page/Tegra%20Linux%20Driver%20Package%20Development%20Guide/accelerated_gstreamer.html#wwpID0E0FR0HA
2_1_getfps_display_mipi()
{
	echo_title "getfps_display_mipi-video${D_DEV_NO}"
	#exec_gstcmd gst-launch-1.0 nvv4l2camerasrc device="/dev/video${D_DEV_NO}" -e ! queue ! \
	#"video/x-raw(memory:NVMM), format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT},interlace-mode= progressive" ! \
	#nvvidconv ! queue ! tee name=t ! queue ! nv3dsink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v 
	
	exec_gstcmd gst-launch-1.0 nvv4l2camerasrc device="/dev/video${D_DEV_NO}" -e ! queue ! \
	"video/x-raw(memory:NVMM), format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	nvvidconv ! queue ! tee name=t ! queue ! nv3dsink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v 
}

2_0_getfps_display()
{
	echo_title "getfps_display-video${D_DEV_NO}"
	case ${D_FORMAT_GST} in
	"YUY2" | "YV12" | "UYVY" | "I420" )
		#xvimagesink-not support NV12
		exec_gstcmd_kmsg gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" num-buffers=${D_NUM_BUFFER}  -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		tee name=t ! queue ! videoconvert ! xvimagesink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false -v ;;
	
		#exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		#tee name=t ! queue ! xvimagesink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false -v ;;
		
	"NV12" )	
		# Result seems same with above, but support NV12
		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		tee name=t ! queue ! nvvidconv ! "video/x-raw(memory:NVMM), format=(string)${D_FORMAT_GST}" ! queue ! nv3dsink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v ;;

	"RGB" )	
		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		videoconvert ! "video/x-raw, format=(string)RGBA" ! queue ! nvvidconv ! "video/x-raw(memory:NVMM),format=RGBA" ! \
		tee name=t ! queue ! nv3dsink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false -v ;;

	"BGR" )	
		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		videoconvert ! "video/x-raw, format=(string)BGRx" ! queue ! nvvidconv ! "video/x-raw(memory:NVMM),format=RGBA" ! \
		tee name=t ! queue ! nv3dsink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false -v ;;
	esac	
}

2_2_getfps_display2YUY2()
{
	#xvimagesink
	exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	tee name=t ! queue ! xvimagesink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false -v 
	
	# Result seems same with above
	#exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	#nvvidconv ! queue ! tee name=t ! queue ! nv3dsink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v 	
}


2_3_getfps_display_scale()
{
	case ${D_FORMAT_GST} in
	"YUY2" | "YV12" | "UYUV" | "I420" )
		#xvimagesink-not support NV12
#		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
#		tee name=t ! queue ! videoscale method=0 add-borders=false ! "video/x-raw, width=(int)${D_WIDTH_SCALE}, height=(int)${D_HEIGHT_SCALE}" ! queue ! \
#		xvimagesink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false -v ;;

		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		videoscale method=0 add-borders=false ! "video/x-raw, width=(int)${D_WIDTH_SCALE}, height=(int)${D_HEIGHT_SCALE}" ! queue! tee name=t ! queue ! \
		xvimagesink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false -v ;;
	
		#exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		#tee name=t ! queue ! xvimagesink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false -v ;;
		
	"NV12")	
		# Result seems same with above, but support NV12
#		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
#		tee name=t ! queue ! videoscale method=0 add-borders=false ! nvvidconv ! "video/x-raw(memory:NVMM), format=(string)${D_FORMAT_GST},width=(int)${D_WIDTH_SCALE}, height=(int)${D_HEIGHT_SCALE}" ! \
#		queue ! nv3dsink sync=false t. ! \
#		queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v ;;

		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		tee name=t ! queue ! nvvidconv ! "video/x-raw(memory:NVMM), format=(string)${D_FORMAT_GST},width=(int)${D_WIDTH_SCALE}, height=(int)${D_HEIGHT_SCALE}" ! \
		queue ! nv3dsink sync=false t. ! \
		queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v ;;
	esac	
}

2_4_display_uptr()
{
	echo_title "2_4_display_uptr-video${D_DEV_NO}"

	# NV12 pass -gree screen, 1080p20
	#exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" io-mode=userptr -e ! \
	#queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	#videoconvert ! "video/x-raw, format=(string)RGBA" !  \
	#tee name=t ! queue ! glimagesink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false -v 
	
	# NV12 pass -gree screen
	exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" io-mode=userptr ! \
	"video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	queue ! videoconvert ! tee name=t ! \
	queue ! xvimagesink sync=false t. ! \
	queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v 

	# NV12  pass -gree screen 1080p20
	#exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" io-mode=userptr -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	#videoconvert ! "video/x-raw, format=(string)BGRx" ! queue ! nvvidconv ! "video/x-raw(memory:NVMM),format=RGBA" ! \
	#tee name=t ! queue ! nv3dsink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false -v 
	
#	case ${D_FORMAT_GST} in
#	"YUY2" | "YV12" | "UYVY" | "I420" )
#		#xvimagesink-not support NV12
#		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" io-mode=userptr -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
#		tee name=t ! queue ! xvimagesink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false -v ;;
#	
#		#exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
#		#tee name=t ! queue ! xvimagesink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false -v ;;
#		
#	"NV12" )	
#		# Result seems same with above, but support NV12
#		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
#		tee name=t ! queue ! nvvidconv ! "video/x-raw(memory:NVMM), format=(string)${D_FORMAT_GST}" ! queue ! nv3dsink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v ;;
#
#	"RGB" )	
#		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
#		videoconvert ! "video/x-raw, format=(string)RGBA" ! queue ! nvvidconv ! "video/x-raw(memory:NVMM),format=RGBA" ! \
#		tee name=t ! queue ! nv3dsink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false -v ;;
#
#	"BGR" )	
#		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
#		videoconvert ! "video/x-raw, format=(string)BGRx" ! queue ! nvvidconv ! "video/x-raw(memory:NVMM),format=RGBA" ! \
#		tee name=t ! queue ! nv3dsink sync=false t. ! queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false -v ;;
#	esac
	
}

# SW encode to h264, and save to file
# https://forums.developer.nvidia.com/t/memory-leak-in-nvvideoconvert-nvv4lh264enc/156890/4
# bufapi-version=false , r34.1.1 remove this property
3_0_en264file()
{
	echo_title "en264file-video${D_DEV_NO}"
	FN="${DIR_CURR}/"$(date +%Y%m%d_%H%M%S)".264"
	
	#exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! \
	#"video/x-raw, format=(string)${D_FORMAT_GST},width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	#tee name=t ! \
	#videoconvert ! queue ! "video/x-raw, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! nvvidconv ! queue ! \
	#"video/x-raw(memory:NVMM), width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	#nvv4l2h264enc bitrate=${BITRATE} iframeinterval=${GOP} bufapi-version=false ! queue ! \
	#h264parse ! queue ! filesink location=${FN} sync=true t. ! \
	#fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v 
	
	# nvvidconv does not support YV12, use videoconvert convert before using
#	exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! \
#	"video/x-raw, format=(string)${D_FORMAT_GST},width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
#	videoconvert ! queue ! \
#	nvvidconv ! queue ! \
#	tee name=t ! queue ! \
#	nvv4l2h264enc bitrate=${BITRATE} iframeinterval=${GOP} bufapi-version=false ! queue ! \
#	h264parse ! queue ! filesink location=${FN} sync=false t. ! \
#	queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v 

	#Orin r34.1.1
	exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! \
	"video/x-raw, format=(string)${D_FORMAT_GST},width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	videoconvert ! queue ! \
	nvvidconv ! queue ! \
	tee name=t ! queue ! \
	nvv4l2h264enc bitrate=${BITRATE} iframeinterval=${GOP} ! queue ! \
	h264parse ! queue ! filesink location=${FN} sync=false t. ! \
	queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v 
}

3_1_en264file_mipi()
{
	echo_title "en264file_mipi-video${D_DEV_NO}"
	exec_gstcmd gst-launch-1.0 nvv4l2camerasrc device="/dev/video${D_DEV_NO}" -e ! \
	"video/x-raw(memory:NVMM), format=(string)${D_FORMAT_GST},width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	nvvidconv ! queue ! \
	tee name=t ! queue ! \
	nvv4l2h264enc bitrate=${BITRATE} iframeinterval=${GOP} bufapi-version=false ! queue ! \
	h264parse ! queue ! filesink location=${FN} sync=false t. ! \
	queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v 
}


4_0_en264file_display()
{
	echo_title "en264file_display-video${D_DEV_NO}"
	FN="${DIR_CURR}/"$(date +%Y%m%d_%H%M%S)".264"
	
	case ${D_FORMAT_GST} in
	"YUY2" | "YV12" | "UYUV" | "I420" )
		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! \
		"video/x-raw, format=(string)${D_FORMAT_GST},width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		tee name=t ! \
		queue ! xvimagesink sync=false t. ! \
		queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false t. ! \
		queue flush-on-eos=true silent=true leaky=0 max-size-buffers=0 max-size-time=0 max-size-bytes=0 ! \
		videoconvert ! queue ! "video/x-raw, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! nvvidconv ! queue ! \
		"video/x-raw(memory:NVMM), width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		nvv4l2h264enc bitrate=${BITRATE} iframeinterval=${GOP} ! queue ! \
		h264parse ! queue ! filesink location=${FN} sync=false  -v ;;

	# xvimagesink does not support NV12 , xvinfo
	"NV12" )
		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! \
		"video/x-raw, format=(string)${D_FORMAT_GST},width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		nvvidconv ! queue ! tee name=t ! \
		queue ! nvv4l2h264enc bitrate=${BITRATE} iframeinterval=${GOP} ! queue ! h264parse ! queue ! filesink location=${FN} sync=false t. ! \
		queue ! nv3dsink sync=false t. ! \
		queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v ;;

	"RGB" )
		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		videoconvert ! "video/x-raw, format=(string)RGBA" ! queue ! nvvidconv ! "video/x-raw(memory:NVMM),format=RGBA" ! \
		tee name=t ! \
		queue ! nv3dsink sync=false t. ! \
		queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false t. ! \
		queue ! nvvidconv ! "video/x-raw(memory:NVMM),format=NV12" !  queue ! nvv4l2h264enc bitrate=${BITRATE} iframeinterval=${GOP} ! \
		queue ! h264parse ! queue ! filesink location=${FN} sync=false -v ;;

	"BGR" )	
		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! queue ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		videoconvert ! "video/x-raw, format=(string)BGRx" ! queue ! nvvidconv ! "video/x-raw(memory:NVMM),format=RGBA" ! \
		tee name=t ! \
		queue ! nv3dsink sync=false t. ! \
		queue ! fpsdisplaysink video-sink=fakesink text-overlay=false  sync=false t. ! \
		queue ! nvvidconv ! "video/x-raw(memory:NVMM),format=NV12" !  queue ! nvv4l2h264enc bitrate=${BITRATE} iframeinterval=${GOP} ! \
		queue ! h264parse ! queue ! filesink location=${FN} sync=false -v ;;
	esac
}

4_1_en264file_display_mipi()
{
	echo_title "en264file_display_mipi-video${D_DEV_NO}"
	run_cmd gst-launch-1.0 nvv4l2camerasrc device="/dev/video${D_DEV_NO}" -e ! \
	"video/x-raw(memory:NVMM), format=(string)${D_FORMAT_GST},width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	nvvidconv ! queue ! \
	tee name=t ! queue ! nv3dsink sync=false t. ! \
	queue flush-on-eos=true silent=true leaky=0 max-size-buffers=0 max-size-time=0 max-size-bytes=0 ! \
	nvv4l2h264enc bitrate=${BITRATE} iframeinterval=${GOP} bufapi-version=false ! queue ! \
	h264parse ! queue ! filesink location=${FN} sync=false t. ! \
	fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v 	
}

5_0_sw_dec264_fps()
{
	TSTART=`date`
	
	#CPU decode
	exec_gstcmd gst-launch-1.0 filesrc location="${1}" -e ! h264parse ! queue ! avdec_h264 ! queue ! videoconvert ! "video/x-raw, width=${D_WIDTH}, height=${D_HEIGHT}" ! \
	queue ! fpsdisplaysink video-sink=fakesink text-overlay=false -v 
	
	#GPU decode - fps is low
	#run_cmd gst-launch-1.0 filesrc location="${1}" -e ! h264parse ! queue ! omxh264dec ! queue ! videoconvert ! "video/x-raw, width=${D_WIDTH}, height=${D_HEIGHT}" ! \
	#queue ! fpsdisplaysink video-sink=fakesink text-overlay=false -v 
	
	TSTOP=`date`
}

6_0_sw_dec264_display()
{
	TSTART=`date`
	exec_gstcmd gst-launch-1.0 filesrc location="${1}" -e ! h264parse ! queue ! avdec_h264 ! queue ! videoconvert ! "video/x-raw, width=${D_WIDTH}, height=${D_HEIGHT}" ! \
	tee name=t ! queue ! xvimagesink sync=false t. !  queue ! fpsdisplaysink video-sink=fakesink text-overlay=false -v 
	TSTOP=`date`
}

5_1_gpu_dec264_fps()
{
	TSTART=`date`
	exec_gstcmd gst-launch-1.0 filesrc location="${1}" -e ! h264parse ! queue ! nvv4l2decoder ! queue ! \
	fpsdisplaysink video-sink=fakesink text-overlay=false -v 
	TSTOP=`date`
}

6_1_gpu_dec264_display()
{
	TSTART=`date`
	exec_gstcmd gst-launch-1.0 filesrc location="${1}" -e ! h264parse ! queue ! nvv4l2decoder ! queue ! \
	tee name=t ! queue ! nv3dsink sync=false t. !  queue ! fpsdisplaysink video-sink=fakesink text-overlay=false -v 		
	TSTOP=`date`
}

# encode raw video from capture, and stream video out with rtp/udp 
# https://stackoverflow.com/questions/28294296/gstreamer-stream-h264-video-from-logitech-c920-over-udp
7_0_rtp_udp_sender_cpu()
{
	echo_title "rtp_udp_sender_cpu-video${D_DEV_NO}"
	exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -v -e ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	queue ! x264enc key-int-max=${GOP} byte-stream=true bitrate=${BITRATE_x264enc} ! queue ! \
	tee name = t ! \
	queue ! h264parse ! queue flush-on-eos=true silent=true leaky=0 max-size-buffers=0 max-size-time=0 max-size-bytes=0 ! \
	mp4mux ! filesink location=${FN} sync=false t. ! \
	queue ! rtph264pay config-interval=4 pt=127 ! queue ! udpsink host=${IP_SERVER} port=${D_PORT} 
}

# nvvidconv, nvv4l2h264enc do not support YV12, must convert to I420 before using.
# nvv4l2h264enc output is memory:NVMM, use h264parse to convert from GPU/memory:NVMM to CPU memory. 
7_1_rtp_udp_sender_gpu()
{
	echo_title "rtp_udp_sender_gpu-video${D_DEV_NO}"
	exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -v -e ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	videoconvert ! queue ! nvvidconv ! queue ! \
	nvv4l2h264enc bitrate=${BITRATE} iframeinterval=${GOP} bufapi-version=false ! queue ! \
	queue ! h264parse ! queue flush-on-eos=true silent=true leaky=0 max-size-buffers=0 max-size-time=0 max-size-bytes=0 ! \
	tee name = t ! \
	queue ! mp4mux ! filesink location=${FN} sync=false t. ! \
	queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false t. ! \
	queue ! rtph264pay config-interval=4 pt=127 ! queue ! udpsink host=${IP_SERVER} port=${D_PORT} 
}

8_0_rtp_udp_receiver_cpu()
{
	echo_title "rtp_udp_receiver-video${D_DEV_NO}"
	exec_gstcmd gst-launch-1.0 udpsrc port=${D_PORT} -v -e ! \
	"application/x-rtp,media=(string)video,encoding-name=(string)H264,clock-rate=90000" ! \
	rtpjitterbuffer ! \
	queue ! rtph264depay ! queue ! avdec_h264 ! \
	tee name=t ! queue ! xvimagesink sync=false t. ! \
	fpsdisplaysink video-sink=fakesink text-overlay=false  	
}

8_1_rtp_udp_receiver_gpu()
{
	echo_title "rtp_udp_receiver-video${D_DEV_NO}"
	exec_gstcmd gst-launch-1.0 udpsrc port=${D_PORT} -v -e ! \
	"application/x-rtp,media=(string)video,encoding-name=(string)H264,clock-rate=90000" ! \
	rtpjitterbuffer ! \
	queue ! rtph264depay ! queue ! nvv4l2decoder ! \
	tee name=t ! queue ! nv3dsink sync=false t. ! \
	fpsdisplaysink video-sink=fakesink text-overlay=false  	
}

# nvv4l2h265enc supports I420, NV12, P010_10LE, NV24
9_0_en265file()
{
	echo_title "en265file-video${D_DEV_NO}"
	# nvvidconv does not support YV12, use videoconvert convert before using

	FN="${DIR_CURR}/"$(date +%Y%m%d_%H%M%S)_h265".265"
	exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! \
	"video/x-raw, format=(string)${D_FORMAT_GST},width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	videoconvert ! queue ! \
	nvvidconv ! "video/x-raw(memory:NVMM), format=(string)NV12" !  queue ! \
	tee name=t ! queue ! \
	nvv4l2h265enc control-rate=${D_265_CTL_RATE} bitrate=${D_265_BRATE} ! queue ! \
	filesink location=${FN} sync=false t. ! \
	queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v
	
}

9_1_en265file_mp4()
{
	echo_title "9_1_en265file_mp4"
	FN="${DIR_CURR}/"$(date +%Y%m%d_%H%M%S)_h265".mp4"

	# nvvidconv does not support YV12, use videoconvert convert before using
	exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! \
	"video/x-raw, format=(string)${D_FORMAT_GST},width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	videoconvert ! queue ! \
	nvvidconv ! "video/x-raw(memory:NVMM), format=(string)NV12" !  queue ! \
	tee name=t ! queue ! \
	nvv4l2h265enc control-rate=${D_265_CTL_RATE} bitrate=${D_265_BRATE} ! queue ! \
	h265parse ! queue ! qtmux ! queue ! filesink location=${FN} sync=false t. ! \
	queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v
}

10_0_en265file_display()
{
	echo_title "10_0_en265file_display-video${D_DEV_NO}"
	FN="${DIR_CURR}/"$(date +%Y%m%d_%H%M%S)_h265".265"
	
	case ${D_FORMAT_GST} in
	"YV12" )
		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! \
		"video/x-raw, format=(string)${D_FORMAT_GST},width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		videoconvert ! queue ! \
		"video/x-raw, format=(string)NV12,width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		nvvidconv ! queue ! \
		tee name=t ! queue ! \
		nvv4l2h265enc control-rate=${D_265_CTL_RATE} bitrate=${D_265_BRATE} ! queue ! \
		h265parse ! queue ! filesink location=${FN} sync=false t. ! \
		queue ! nv3dsink sync=false t. ! \
		queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v ;;
		
	# xvimagesink does not support NV12 , xvinfo
	"NV12" | "YUY2" | "UYUV" | "I420" )
		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! \
		"video/x-raw, format=(string)${D_FORMAT_GST},width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		nvvidconv ! queue ! \
		"video/x-raw(memory:NVMM), format=(string)NV12,width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		tee name=t ! queue ! \
		nvv4l2h265enc control-rate=${D_265_CTL_RATE} bitrate=${D_265_BRATE} ! queue ! \
		h265parse ! queue ! filesink location=${FN} sync=false t. ! \
		queue ! nv3dsink sync=false t. ! \
		queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v ;;
	esac
}

10_1_en265file_display_mp4()
{
	echo_title "10_1_en265file_display_mp4"
	FN="${DIR_CURR}/"$(date +%Y%m%d_%H%M%S)_h265".mp4"
	
	case ${D_FORMAT_GST} in
	"YV12" )
		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! \
		"video/x-raw, format=(string)${D_FORMAT_GST},width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		videoconvert ! queue ! \
		"video/x-raw, format=(string)NV12,width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		nvvidconv ! queue ! \
		tee name=t ! queue ! \
		nvv4l2h265enc control-rate=${D_265_CTL_RATE} bitrate=${D_265_BRATE} ! queue ! \
		h265parse ! queue ! qtmux ! queue ! filesink location=${FN} sync=false t. ! \
		queue ! nv3dsink sync=false t. ! \
		queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v ;;
		
	# xvimagesink does not support NV12 , xvinfo
	"NV12" | "YUY2" | "UYUV" | "I420" )
		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -e ! \
		"video/x-raw, format=(string)${D_FORMAT_GST},width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		nvvidconv ! queue ! \
		"video/x-raw(memory:NVMM), format=(string)NV12,width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		tee name=t ! queue ! \
		nvv4l2h265enc control-rate=${D_265_CTL_RATE} bitrate=${D_265_BRATE} ! queue ! \
		h265parse ! queue ! qtmux ! queue ! filesink location=${FN} sync=false t. ! \
		queue ! nv3dsink sync=false t. ! \
		queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false -v ;;
	esac
}

11_1_gpu_dec265_fps()
{
	TSTART=`date`
	exec_gstcmd gst-launch-1.0 filesrc location="${1}" -e ! \
	h265parse ! queue ! nvv4l2decoder ! queue ! \
	fpsdisplaysink video-sink=fakesink text-overlay=false -v 
	TSTOP=`date`
}

11_2_gpu_dec265_fps_mp4()
{
	TSTART=`date`
	exec_gstcmd gst-launch-1.0 filesrc location="${1}" -e ! \
	qtdemux name=demux demux.video_0 ! \
	h265parse ! queue ! nvv4l2decoder ! queue ! \
	fpsdisplaysink video-sink=fakesink text-overlay=false -v 
	TSTOP=`date`
}

12_1_gpu_dec265_display()
{
	TSTART=`date`
	exec_gstcmd gst-launch-1.0 filesrc location="${1}" -e ! h265parse ! queue ! nvv4l2decoder ! queue ! \
	tee name=t ! queue ! nv3dsink sync=false t. !  queue ! fpsdisplaysink video-sink=fakesink text-overlay=false -v 		
	TSTOP=`date`
}

12_2_gpu_dec265_display_mp4()
{
	TSTART=`date`
	exec_gstcmd gst-launch-1.0 filesrc location="${1}" -e ! \
	qtdemux name=demux demux.video_0 ! \
	h265parse ! queue ! nvv4l2decoder ! queue ! \
	tee name=t ! \
	queue ! fpsdisplaysink video-sink=fakesink text-overlay=false t. -v ! \
	queue ! nv3dsink sync=false -v
	TSTOP=`date`
}

13_1_rtp265_udp_sender_gpu()
{
	echo_title "13_1_rtp_udp_sender_gpu"
	FN="${DIR_CURR}/"$(date +%Y%m%d_%H%M%S)_h265".mp4"
	exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -v -e ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
	videoconvert ! queue ! nvvidconv ! queue ! \
	nvv4l2h265enc control-rate=${D_265_CTL_RATE} bitrate=${D_265_BRATE} ! queue ! \
	queue ! h265parse ! queue flush-on-eos=true silent=true leaky=0 max-size-buffers=0 max-size-time=0 max-size-bytes=0 ! \
	tee name = t ! \
	queue ! mp4mux ! filesink location=${FN} sync=false t. ! \
	queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false t. ! \
	queue ! rtph265pay config-interval=4 pt=127 ! queue ! udpsink host=${IP_SERVER} port=${D_PORT} 
}

13_2_rtp265_udp_sender_gpu_720p()
{
	echo_title "13_2_rtp265_udp_sender_gpu_720p"
	FN="${DIR_CURR}/"$(date +%Y%m%d_%H%M%S)_h265".mp4"
	
	case ${D_FORMAT_GST} in
	"YV12" )
		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -v -e ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		videoconvert ! nvvidconv ! queue ! "video/x-raw(memory:NVMM), width=(int)1280, height=(int)720" ! \
		nvv4l2h265enc control-rate=${D_265_CTL_RATE} bitrate=${D_265_BRATE} ! queue ! \
		queue ! h265parse ! queue flush-on-eos=true silent=true leaky=0 max-size-buffers=0 max-size-time=0 max-size-bytes=0 ! \
		tee name = t ! \
		queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false t. ! \
		queue ! rtph265pay config-interval=4 pt=127 ! queue ! udpsink host=${IP_SERVER} port=${D_PORT} ;;

	"NV12" | "YUY2" | "UYUV" | "I420" )
#		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -v -e ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
#		nvvidconv ! queue ! "video/x-raw(memory:NVMM), width=(int)1280, height=(int)720" ! \
#		nvv4l2h265enc control-rate=${D_265_CTL_RATE} bitrate=${D_265_BRATE} ! queue ! \
#		queue ! h265parse ! queue flush-on-eos=true silent=true leaky=0 max-size-buffers=0 max-size-time=0 max-size-bytes=0 ! \
#		tee name = t ! \
#		queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false t. ! \
#		queue ! rtph265pay config-interval=4 pt=127 ! queue ! udpsink host=${IP_SERVER} port=${D_PORT} ;;

		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -v -e ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
		nvvidconv ! queue ! "video/x-raw(memory:NVMM), width=(int)1280, height=(int)720" ! \
		nvv4l2h265enc control-rate=${D_265_CTL_RATE} bitrate=${D_265_BRATE} ! queue ! \
		queue ! h265parse ! queue flush-on-eos=true silent=true leaky=0 max-size-buffers=0 max-size-time=0 max-size-bytes=0 ! \
		tee name = t ! \
		queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false t. ! \
		queue ! rtph265pay config-interval=4 pt=127 ! queue ! multiudpsink clients=${IP_SERVER}:${D_PORT} ;;

#		exec_gstcmd gst-launch-1.0 v4l2src device="/dev/video${D_DEV_NO}" -v -e ! "video/x-raw, format=(string)${D_FORMAT_GST}, width=(int)${D_WIDTH}, height=(int)${D_HEIGHT}" ! \
#		nvvidconv ! queue ! "video/x-raw(memory:NVMM), width=(int)1280, height=(int)720"  ! \
#		nvv4l2h265enc control-rate=${D_265_CTL_RATE} bitrate=${D_265_BRATE} ! queue ! \
#		tee name = t ! \
#		queue ! fpsdisplaysink video-sink=fakesink text-overlay=false sync=false t. ! \
#		queue ! mpegtsmux ! rtpmp2tpay ! queue ! multiudpsink clients=${IP_SERVER}:${D_PORT} ;;
	esac
}

14_0_rtp265_udp_receiver_cpu()
{
	echo_title "14_0_rtp265_udp_receiver_cpu"
	exec_gstcmd gst-launch-1.0 udpsrc port=${D_PORT} -v -e ! \
	"application/x-rtp,media=(string)video,encoding-name=(string)H265,clock-rate=90000" ! \
	rtpjitterbuffer ! \
	queue ! rtph265depay ! queue ! avdec_h265 ! \
	tee name=t ! queue ! xvimagesink sync=false t. ! \
	fpsdisplaysink video-sink=fakesink text-overlay=false  	
}

14_1_rtp265_udp_receiver_gpu()
{
	echo_title "14_1_rtp265_udp_receiver_gpu"
	exec_gstcmd gst-launch-1.0 udpsrc port=${D_PORT} -v -e ! \
	"application/x-rtp,media=(string)video,encoding-name=(string)H265,clock-rate=90000" ! \
	rtpjitterbuffer ! \
	queue ! rtph265depay ! queue ! nvv4l2decoder ! \
	tee name=t ! queue ! nv3dsink sync=false t. ! \
	fpsdisplaysink video-sink=fakesink text-overlay=false  	
}

14_2_rtp265_udp_receiver_vaapi()
{
	echo_title "14_2_rtp265_udp_receiver_vaapi"
	exec_gstcmd gst-launch-1.0 udpsrc port=${D_PORT} -v -e ! \
	"application/x-rtp,media=(string)video,encoding-name=(string)H265,clock-rate=90000" ! \
	rtpjitterbuffer ! \
	queue ! rtph265depay ! queue ! vaapih265dec ! \
	tee name=t ! queue ! xvimagesink sync=false t. ! \
	fpsdisplaysink video-sink=fakesink text-overlay=false  	
}

14_3_rtp265_udp_receiver_cpu_mp2t()
{
	echo_title "14_3_rtp265_udp_receiver_cpu_mp2t"
	exec_gstcmd gst-launch-1.0 udpsrc port=${D_PORT} -v -e ! \
	"application/x-rtp,media=(string)video,encoding-name=(string)MP2T,clock-rate=90000" ! \
	rtpjitterbuffer ! \
	queue ! rtpmp2tdepay ! queue ! tsdemux ! queue ! \
	tee name=t ! queue ! xvimagesink sync=false t. ! \
	fpsdisplaysink video-sink=fakesink text-overlay=false  	
}

#1.get fps without display
1_test_get_fps()
{
	if [ "${D_IS_MIPI}" == "1" ];then
		1_1_getfps_mipi
	else
		1_0_getfps
	fi	
}

#2.get fps with display
2_test_get_fps_with_display()
{
	if [ "${D_IS_MIPI}" == "1" ];then
		2_1_getfps_display_mipi
	else
		case ${D_DRIVER_MODE} in
		
		${D_DMODE_USERPRT} )   	2_4_display_uptr ;;
		${D_DMODE_GPUDIRECT} )	2_5_display_dgpu ;;
		* ) 2_0_getfps_display;;
		   #57_test_rgba
		   #58_test_bgra
		   #59_test_rgb_nveglglessink
		esac
	fi
}

#3.encode264 to file
3_test_encode264_to_file()
{
	if [ "${D_IS_MIPI}" == "1" ];then
		3_1_en264file_mipi
	else
		3_0_en264file
	fi	
}

#4.encode264 to file with display
4_test_encode264_to_file_with_display()
{
	if [ "${D_IS_MIPI}" == "1" ];then
		4_1_en264file_display_mipi
	else
		4_0_en264file_display
	fi	
}

#5.decode264 from file
5_test_decode264_from_file()
{
	echo_title "test_decode264_from_file-video${D_DEV_NO}"
	#6_0_sw_dec264_fps $@
	5_1_gpu_dec264_fps $@
}

#6.decode264 from file with display	
6_test_decode264_from_file_with_display()
{
	echo_title "test_decode264_from_file_with_display-video${D_DEV_NO}"
	#6_0_sw_dec264_display $@
	6_1_gpu_dec264_display $@
}

#7.encode264 to file , and rtp stream output
7_test_rtp_udp_sender()
{
	echo_title "test_encode264_to_file_rtp_send-video${D_DEV_NO}"
	#7_0_rtp_udp_sender_cpu $@
	7_1_rtp_udp_sender_gpu $@
}

#8.receive h264 rtp stream 
8_test_rtp_udp_receiver()
{
	echo_title "test_decode264_rtp_receive-video${D_DEV_NO}"
	8_0_rtp_udp_receiver_cpu $@
	#8_1_rtp_udp_receiver_gpu $@
}

#9.encode H265 to file
9_test_en265_2file()
{
	if [ "${D_SAVE_FTYPE}" == "${D_FILE_H265}" ];then
		9_0_en265file
	else
		9_1_en265file_mp4
	fi
}

#10.encode265 to file with display
10_test_en265_2file_display()
{
	if [ "${D_SAVE_FTYPE}" == "${D_FILE_H265}" ];then
		10_0_en265file_display
	else
		10_1_en265file_display_mp4
	fi
	
}

#11.decode265 from file
11_test_dec265_file()
{
	echo_title "test_decode265_from_file-video${D_DEV_NO}"
	if [ "${D_SAVE_FTYPE}" == "${D_FILE_H265}" ];then
		11_1_gpu_dec265_fps $@
	else
		11_2_gpu_dec265_fps_mp4 $@
	fi
}

#12.decode265 from file with display	
12_test_dec265_file_display()
{
	echo_title "test_decode265_from_file_with_display-video${D_DEV_NO}"
	if [ "${D_SAVE_FTYPE}" == "${D_FILE_H265}" ];then
		12_1_gpu_dec265_display $@
	else
		12_2_gpu_dec265_display_mp4 $@
	fi
}

#13.encode265 to file , and rtp stream output
13_test_rtp265_udp_sender()
{
	echo_title "13_test_rtp265_udp_sender"
	if [ "${D_SCALE_720P}" == "0" ];then
		#13_0_rtp265_udp_sender_cpu $@
		13_1_rtp265_udp_sender_gpu $@
	else
		13_2_rtp265_udp_sender_gpu_720p
	fi
}

#14.receive h265 rtp stream 
14_test_rtp265_udp_receiver()
{
	echo_title "14_test_rtp265_udp_receiver"
	14_0_rtp265_udp_receiver_cpu $@
	#14_1_rtp265_udp_receiver_gpu $@
}

0_test_performance()
{
	echo "test_performance"
	D_BACKGROUND=0
	#D_BACKGROUND=${D_DEV_NO}
	
	#55_set_nvpmodel
	#56_set_fan
	
	#--set-dv-bt-timings
	#D_DEV_NO=${i}
#	if [ ${D_FORMAT_GST} == "YUY2" ]; then
#		run_cmd v4l2-ctl -d ${D_DEV_NO} -i ${D_DEV_INPUT} --set-fmt-video=pixelformat=YUYV 
#	else
#		run_cmd v4l2-ctl -d ${D_DEV_NO} -i ${D_DEV_INPUT} --set-fmt-video=pixelformat=${D_FORMAT_GST} 
#	fi


	case ${P1_ID_CASE} in
	[1-4] | 7 | [9-10] | 13)
		 if [ ${D_FORMAT_GST} == "YUY2" ]; then
			run_cmd2kmsg v4l2-ctl -d ${D_DEV_NO} -i ${D_DEV_INPUT} --set-fmt-video=pixelformat=YUYV --set-dv-bt-timings=width=${D_WIDTH},height=${D_HEIGHT} 
			#run_cmd v4l2-ctl -d ${D_DEV_NO} -i ${D_DEV_INPUT} --set-fmt-video=pixelformat=YUYV,width=${D_WIDTH},height=${D_HEIGHT} -p ${FRAMERATE}
		 elif [ ${D_FORMAT_GST} == "I420" ]; then
			run_cmd v4l2-ctl -d ${D_DEV_NO} -i ${D_DEV_INPUT} --set-fmt-video=pixelformat=YU12 --set-dv-bt-timings=width=${D_WIDTH},height=${D_HEIGHT}
		elif [ "${D_FORMAT_GST}" == "BGR" ]; then
			run_cmd v4l2-ctl -d ${D_DEV_NO} -i ${D_DEV_INPUT} --set-fmt-video=pixelformat=BGR3 --set-dv-bt-timings=width=${D_WIDTH},height=${D_HEIGHT}
		elif [ "${D_FORMAT_GST}" == "RGB" ]; then
			run_cmd v4l2-ctl -d ${D_DEV_NO} -i ${D_DEV_INPUT} --set-fmt-video=pixelformat=RGB3 --set-dv-bt-timings=width=${D_WIDTH},height=${D_HEIGHT}
		 else
			run_cmd2kmsg v4l2-ctl -d ${D_DEV_NO} -i ${D_DEV_INPUT} --set-fmt-video=pixelformat=${D_FORMAT_GST} --set-dv-bt-timings=width=${D_WIDTH},height=${D_HEIGHT}
			#run_cmd v4l2-ctl -d ${D_DEV_NO} -i ${D_DEV_INPUT} --set-fmt-video=pixelformat=${D_FORMAT_GST},width=${D_WIDTH},height=${D_HEIGHT} -p ${FRAMERATE}
		 fi
		 ;;
	esac
	
	sleep 1

	case ${P1_ID_CASE} in
		'1' )		1_test_get_fps ;;
		'2' )		2_test_get_fps_with_display  ;;
		'3' )		3_test_encode264_to_file ;;
		'4' )		4_test_encode264_to_file_with_display  ;;
		'5' )		5_test_decode264_from_file ${P3_FN_DEC};;
		'6' )		6_test_decode264_from_file_with_display  ${P3_FN_DEC};;
		'7' )		
			FN="${DIR_CURR}/"$(date +%Y%m%d_%H%M%S)".mp4"
			7_test_rtp_udp_sender  ${P3_FN_DEC};;
		'8' )		8_test_rtp_udp_receiver ${P3_FN_DEC};;
		'9' )		9_test_en265_2file ;;
		'10')		10_test_en265_2file_display  ;;
		'11' )		11_test_dec265_file ${P3_FN_DEC};;
		'12' )		12_test_dec265_file_display  ${P3_FN_DEC};;
		'13' )		13_test_rtp265_udp_sender ${P3_FN_DEC};;
		'14' )		14_test_rtp265_udp_receiver  ${P3_FN_DEC};;
		* )			echo "Test Case ${P2_IS_MULTI} is not supported"
	esac
	#52_win_reset
}

0_test_performance_n()
{
	echo "test_performance_n"
	D_BACKGROUND=1
	
	#55_set_nvpmodel
	#56_set_fan
	 

for (( i=0; i<$D_NO_MULT_CHAN; i++ ))
do	
	#n=$((i*2)) 
	n=$((i+0)) 
	D_DEV_NO=${n}
	
	# port number +1 
	(( D_PORT += 1 ))
	case ${P1_ID_CASE} in
		[1-4] | 7 | [9-10] | 13)

		if [ ${D_FORMAT_GST} == "YUY2" ]; then
			run_cmd v4l2-ctl -d ${D_DEV_NO} -i ${D_DEV_INPUT} --set-fmt-video=pixelformat=YUYV -p ${FRAMERATE}
		 elif [ ${D_FORMAT_GST} == "I420" ]; then
			run_cmd v4l2-ctl -d ${D_DEV_NO} -i ${D_DEV_INPUT} --set-fmt-video=pixelformat=YU12,width=${D_WIDTH},height=${D_HEIGHT} -p ${FRAMERATE}
		else
			run_cmd v4l2-ctl -d ${D_DEV_NO} -i ${D_DEV_INPUT} --set-fmt-video=pixelformat=${D_FORMAT_GST} -p ${FRAMERATE}
		fi
	esac
		
	FN="${DIR_CURR}/"$(date +%Y%m%d_%H%M%S)".264"
	sleep 1
	TIME_DELAY=1
	case ${P1_ID_CASE} in
		'1' ) 		1_test_get_fps ;;
		'2' )		
			2_test_get_fps_with_display  
			TIME_DELAY=5 ;;

		'3' )		3_test_encode264_to_file ;;

		'4' )		
			4_test_encode264_to_file_with_display  
			TIME_DELAY=3 ;;
		'5' )		5_test_decode264_from_file ${P3_FN_DEC};;
		'6' )		6_test_decode264_from_file_with_display  ${P3_FN_DEC};;
		'7' )
			# The mp4 file will broken if terminal by killl script, it better to run the chanel one by one script, not use the background mode.
			# 
			FN="${DIR_CURR}/"$(date +%Y%m%d_%H%M%S)".mp4"
			7_test_rtp_udp_sender ;;
		'8' )		7_test_rtp_udp_receiver;;
		'9' )		9_test_en265_2file ;;
		'10')		10_test_en265_2file_display  ;;
		'11' )		11_test_dec265_file ${P3_FN_DEC};;
		'12' )		12_test_dec265_file_display  ${P3_FN_DEC};;
		'13' )		13_test_rtp265_udp_sender ${P3_FN_DEC};;
		'14' )		14_test_rtp265_udp_receiver  ${P3_FN_DEC};;
		* )			
			echo "Test Case ${P2_IS_MULTI} is not supported"
			exit ;;
			
	esac
	sleep ${TIME_DELAY} 

done
}

usage()
{
	echo "./performance.sh TestCaseID isMultiChannel [FileName for decodeH264]"
	echo "TestCaseID -  1 : get fps of raw stream without display"
	echo "              2 : get fps of raw stream with    display"
	echo "              3 : get fps of encode h264 to file without display"
	echo "              4 : get fps of encode h264 to file with display"
	echo "              5 : get fps of deccode h264 from file without display"
	echo "              6 : get fps of deccode h264 from file with display"
	echo "              7 : get fps of encode udp/rtp stream and record to file"
	echo "              8 : get fps of deccode udp/rtp stream and display"
	echo "              9 : get fps of encode h265 to file without display"
	echo "             10 : get fps of encode h265 to file with display"
	echo "             11 : get fps of deccode h265 from file without display"
	echo "             12 : get fps of deccode h265 from file with display"
	echo "isMultiChannel - [0|n|N} [1/y/Y]"
	
}


_main_org()
{
	echo "main"
	#51_get_dev_no$#"
	
	echo "parameters number= $#"
	 
	if [[ $# < 1 ]];then
		usage
		exit
	fi
	P1_ID_CASE=${1}

	if [[ $# > 1 ]];then
		P2_IS_MULTI=${2}
	fi

	if [[ $# > 2 ]];then
		P3_FN_DEC=${3}
	fi
	
	echo "P1_ID_CASE=${P1_ID_CASE},P2_IS_MULTI=${P2_IS_MULTI},P3_FN_DEC=${P3_FN_DEC}" 
	#get_machine


	case ${P2_IS_MULTI} in
		0 | 'n' | 'N' )		0_test_performance ;;
		1 | 'y' | 'Y' )		0_test_performance_n  ;;
	esac
}

# Play mipi video0 and video1 for catching debug log
main()
{
	P1_ID_CASE=2
	P2_IS_MULTI=0
	D_DEV_NO=0
	echo_title_2kmsg "1.Test video${D_DEV_NO} start"
	0_test_performance
	echo_title_2kmsg "2.Test video${D_DEV_NO} stop"
}

main $@

